package com.example.mymvvmdemo.base

import android.app.ProgressDialog
import android.os.Bundle
import android.util.Log
import androidx.databinding.ViewDataBinding
import com.example.common.base.activity.BaseVmActivity
import com.example.common.base.activity.BaseVmDbActivity
import com.example.common.base.viewmodel.BaseViewModel

/**
 * <pre>
 *     author : louis wang
 *     time   : 2020/06/22
 *     desc   :
 *     version: 1.0
 * </pre>
 */
abstract class BaseActivity<VM : BaseViewModel, DB : ViewDataBinding> : BaseVmDbActivity<VM, DB>() {

    lateinit var loading: ProgressDialog

    abstract override fun layoutId(): Int

    abstract override fun initView(savedInstanceState: Bundle?)

    abstract override fun createObserver()

    override fun showLoading(message: String) {
        if (!::loading.isInitialized) {
            loading = ProgressDialog(this)
        }
        loading.show()
        Log.e("BaseActivity:", message)
    }

    override fun dismissLoading() {
        if (::loading.isInitialized && loading.isShowing) {
            loading.dismiss()
        }
        Log.e("BaseActivity:", "loading is dismissed")
    }
}