package com.example.mymvvmdemo.ui.activity

import android.os.Bundle
import androidx.lifecycle.Observer
import androidx.recyclerview.widget.LinearLayoutManager
import com.example.mymvvmdemo.ui.viewmodel.ListViewModel
import com.example.mymvvmdemo.R
import com.example.mymvvmdemo.base.BaseActivity
import com.example.mymvvmdemo.databinding.ListActivityBinding
import com.example.mymvvmdemo.ext.init
import com.example.mymvvmdemo.ui.adapter.ListAdapter

/**
 * <pre>
 *     author : louis wang
 *     time   : 2020/06/23
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class ListActivity : BaseActivity<ListViewModel, ListActivityBinding>() {

    override fun layoutId(): Int = R.layout.list_activity

    val adapter by lazy { ListAdapter(arrayListOf()) }

    override fun initView(savedInstanceState: Bundle?) {
        mDataBind.viewModel = mViewModel
        mDataBind.swipeRefresh.setOnRefreshListener { mViewModel.getData() }
        mDataBind.recycleView.init(LinearLayoutManager(this), adapter).let {

        }
        adapter.setOnItemClickListener { adapter, view, position ->
        }
    }

    override fun createObserver() {
        mViewModel.urlDataState.observe(this, Observer {
            mDataBind.swipeRefresh.isRefreshing = false
            if (it.isSuccess) {
                //成功
                when {
                    //第一页并没有数据 显示空布局界面
                    it.isEmpty -> {

                    }
                    else -> {
                        adapter.setNewInstance(it.listData)
                    }
                }
            } else {
                //失败

            }
        })
    }
}