package com.example.mymvvmdemo.ui.activity

import android.content.Intent
import android.os.Bundle
import android.widget.Toast
import androidx.lifecycle.Observer
import com.example.common.ext.parseState
import com.example.mymvvmdemo.ui.viewmodel.MainViewModel
import com.example.mymvvmdemo.R
import com.example.mymvvmdemo.base.BaseActivity
import com.example.mymvvmdemo.databinding.ActivityMainBinding

class MainActivity : BaseActivity<MainViewModel, ActivityMainBinding>() {

    override fun layoutId(): Int = R.layout.activity_main

    override fun initView(savedInstanceState: Bundle?) {
        mDataBind.viewModel = mViewModel
        mDataBind.btnLogin.setOnClickListener {
            when {
                mViewModel.phone.value!!.isEmpty() -> {
                    Toast.makeText(this, "请填写账号", Toast.LENGTH_SHORT).show()
                }
                mViewModel.pwd.value!!.isEmpty() -> {
                    Toast.makeText(this, "请填写密码", Toast.LENGTH_SHORT).show()
                }
                else -> mViewModel.login(
                        mViewModel.phone.value ?: "",
                        mViewModel.pwd.value ?: ""
                )
            }
        }
    }

    override fun createObserver() {
        mViewModel.loginResult.observe(this, Observer {
            parseState(it, {
                Toast.makeText(this, "登陆成功", Toast.LENGTH_SHORT).show()
                startActivity(Intent(this, ListActivity::class.java))
            }, {
                //登录失败
                Toast.makeText(this, it.errorMsg, Toast.LENGTH_SHORT).show()
            })
        })

    }
}