package com.example.mymvvmdemo.ui.adapter

import android.widget.ImageView
import com.bumptech.glide.Glide
import com.chad.library.adapter.base.BaseQuickAdapter
import com.chad.library.adapter.base.viewholder.BaseViewHolder
import com.example.mymvvmdemo.R
import com.example.mymvvmdemo.data.ListResponse

/**
 * <pre>
 *     author : louis wang
 *     time   : 2020/06/23
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class ListAdapter(data: ArrayList<ListResponse>) :
        BaseQuickAdapter<ListResponse, BaseViewHolder>(
                R.layout.list_item, data
        ) {
    override fun convert(holder: BaseViewHolder, item: ListResponse) {
        holder.setText(R.id.tvTitle, item.name)
        holder.setText(R.id.tvLink, item.link)
        Glide.with(context)
                .load(item.icon)
                .error(R.mipmap.ic_launcher)
                .placeholder(R.mipmap.ic_launcher)
                .into(holder.getView(R.id.image))
    }


}