package com.example.mymvvmdemo.ui.viewmodel

import android.app.Application
import androidx.lifecycle.MutableLiveData
import com.example.common.base.viewmodel.BaseViewModel
import com.example.common.ext.request
import com.example.mymvvmdemo.data.ListDataUiState
import com.example.mymvvmdemo.data.ListResponse
import com.example.mymvvmdemo.network.HttpRequestManger

/**
 * <pre>
 *     author : louis wang
 *     time   : 2020/06/23
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class ListViewModel(application: Application) : BaseViewModel(application) {


    var urlDataState = MutableLiveData<ListDataUiState<ListResponse>>()

    override fun onStart() {
        super.onStart()
        getData()
    }

    fun getData() {
        request({ HttpRequestManger.instance.collectUrlData() }, {
            //请求成功
            val listDataUiState =
                    ListDataUiState(
                            isRefresh = true,
                            isSuccess = true,
                            hasMore = false,
                            isEmpty = it.isEmpty(),
                            listData = it
                    )
            urlDataState.postValue(listDataUiState)
        }, {
            //请求失败
            val listDataUiState =
                    ListDataUiState(
                            isSuccess = false,
                            errMessage = it.errorMsg,
                            listData = arrayListOf<ListResponse>()
                    )
            urlDataState.postValue(listDataUiState)
        },false)
    }
}