package com.example.mymvvmdemo.ui.viewmodel

import android.app.Application
import androidx.lifecycle.MutableLiveData
import com.example.common.base.viewmodel.BaseViewModel
import com.example.common.ext.request
import com.example.common.state.ResultState
import com.example.mymvvmdemo.data.UserInfo
import com.example.mymvvmdemo.network.HttpRequestManger

/**
 * <pre>
 *     author : louis wang
 *     time   : 2020/06/22
 *     desc   :
 *     version: 1.0
 * </pre>
 */
class MainViewModel(application: Application) : BaseViewModel(application) {

    var phone = MutableLiveData("")
    var pwd = MutableLiveData("")

    var loginResult = MutableLiveData<ResultState<UserInfo>>()

    fun login(phone: String, pwd: String) {
        request(
                { HttpRequestManger.instance.login(phone, pwd) }
                , loginResult,
                true,
                "正在登录中...")
//         //在当前Viewmodel中就拿到了脱壳数据数据，做一层封装再给Activity/Fragment
//        request({ HttpRequestManger.instance.login(phone, pwd) }, {
//
//        }, {
//
//        }, true, "数据请求中...")

        /*requestNoCheck({HttpRequestManger.instance.login(username,password)},{
          //请求成功 自己拿到数据做业务需求操作
          if(it.errorCode==0){
              //结果正确
          }else{
              //结果错误
          }
      },{
          //请求失败 网络异常回调在这里
      })*/
    }

}