package com.example.common.base.fragment

import android.os.Bundle
import android.view.LayoutInflater
import android.view.View
import android.view.ViewGroup
import androidx.databinding.DataBindingUtil
import androidx.databinding.ViewDataBinding
import com.example.common.base.viewmodel.BaseViewModel

/**
 * <pre>
 *     author : louis wang
 *     time   : 2020/06/22
 *     desc   : 包含ViewModel和Databinding的Fragment基类
 *     version: 1.0
 * </pre>
 */
abstract class BaseVmDbFragment<VM : BaseViewModel, DB : ViewDataBinding> : BaseVmFragment<VM>() {

    //该类绑定的ViewDataBinding
    lateinit var mDataBind: DB

    override fun onCreateView(
            inflater: LayoutInflater,
            container: ViewGroup?,
            savedInstanceState: Bundle?
    ): View? {
        mDataBind = DataBindingUtil.inflate(inflater, layoutId(), container, false)
        mDataBind.lifecycleOwner = this
        return mDataBind.root
    }

    override fun onDestroy() {
        super.onDestroy()
        if (::mDataBind.isInitialized) {
            mDataBind.unbind()
        }
    }

}