package com.example.common.base.viewmodel

import android.app.Application
import android.content.Context
import androidx.lifecycle.AndroidViewModel
import androidx.lifecycle.Lifecycle
import androidx.lifecycle.LifecycleOwner
import com.example.common.base.BaseApplication
import com.example.common.event.SingleLiveEvent
import kotlin.reflect.KParameter

/**
 * <pre>
 *     author : louis wang
 *     time   : 2020/06/22
 *     desc   : ViewModel基类
 *     version: 1.0
 * </pre>
 */
open class BaseViewModel(application: Application) : AndroidViewModel(application), IBaseViewModel {

//    var context: Context
    var hasAttached = true

//    constructor(application: Application = BaseApplication.instance) : super(application) {
//        this.context = application.applicationContext
//    }

    val loadingChange: UiLoadingChange by lazy { UiLoadingChange() }

    /**
     * 内置封装好的可通知Activity/fragment 显示隐藏加载框
     */
    inner class UiLoadingChange {
        //显示加载框
        val showDialog by lazy { SingleLiveEvent<String>() }

        //隐藏
        val dismissDialog by lazy { SingleLiveEvent<Void>() }
    }

    override fun onAny(owner: LifecycleOwner, event: Lifecycle.Event) {
    }

    override fun onCreate() {
        hasAttached = true
    }

    override fun onDestroy() {
        hasAttached = false
    }

    override fun onStart() {
    }

    override fun onStop() {
    }

    override fun onResume() {
    }

    override fun onPause() {
    }

}