package com.example.common.network

/**
 * <pre>
 *     author : louis wang
 *     time   : 2020/06/22
 *     desc   : 服务器返回数据的基类 实现抽象方法，根据自己的业务判断返回请求结果是否成功
 *     version: 1.0
 * </pre>
 */
abstract class BaseResponse<T> {

    abstract fun isSuccess(): Boolean

    abstract fun getResponseData(): T

    abstract fun getResponseCode(): Int

    abstract fun getResponseMsg(): String
}