package com.example.common.network.error

/**
 * <pre>
 *     author : louis wang
 *     time   : 2020/06/22
 *     desc   : 自定义错误信息异常
 *     version: 1.0
 * </pre>
 */
class AppException : Exception {
    var errorMsg: String //错误消息
    var errorCode: Int = 0 //错误码

    constructor(errCode: Int, error: String?) : super(error) {
        this.errorMsg = error ?: "错误，请稍后再试"
        this.errorCode = errCode
    }

    constructor(error: Error, e: Throwable?) {
        errorCode = error.getKey()
        errorMsg = error.getValue()
    }
}